/*****************************************************************************
 *	aisa23w.c
 *
 *	aISA-P23
 *
 *	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
 *
 *	Date 1998/05/20
 *
 *****************************************************************************/
#include <windows.h>
#include <tchar.h>
#include "aisa23w.h"	// aISA-P23

//---------- X^eBbN֐ & X^eBbNϐ(萔)	----------------------
static BOOL Aisa23wGetDllExportFunc();
static HMODULE hDLL = NULL;

// DLL GNX|[g֐AhX̊i[pϐ
static FARPROC pAisa23GetVersion;
static FARPROC pAisa23Create;
static FARPROC pAisa23Close;
static FARPROC pAisa23GetResource;
static FARPROC pAisa23OutPort;
static FARPROC pAisa23GetLastError;

BOOL Aisa23wDllOpen ( void )
/*****************************************************************************
 * @\  aisa23.dll[h
 * 	 Ȃ
 * ߒl	 TRUE  --- 
 *		 FALSE --- s
 *****************************************************************************/
{
	if (hDLL != NULL) {
		return FALSE;
	}
	hDLL = (HMODULE)LoadLibrary(AISA23_DLL_NAME);
	if (hDLL == NULL) {
		return FALSE;
	}
	if (Aisa23wGetDllExportFunc() == FALSE) {
		// DLL GNX|[g֐擾ɎŝŁADLL N[Y
		Aisa23wDllClose();
		return FALSE;
	}
	return TRUE;
}

BOOL Aisa23wDllClose ( void )
/*****************************************************************************
 * @\  aisa23.dllA[h
 * 	 Ȃ
 * ߒl	 TRUE  --- 
 *		 FALSE --- s
 *****************************************************************************/
{
	if (hDLL == NULL) {
		return FALSE;
	}
	if (FreeLibrary(hDLL) == TRUE) {
		hDLL = NULL;
		return TRUE;
	}
	return FALSE;
}

BOOL Aisa23wGetVersion ( PDWORD pdwDllVer, PDWORD pdwDrvVer )
/*****************************************************************************
 * @\  aISA-P23DLL,Driver̃o[Wԍ擾
 * 	 pdwDllVer --- DLLo[Wԍi[AhX
 *		 pdwDrvVer --- Drivero[Wԍi[AhX
 * ߒl	 TRUE	   --- 
 *		 FALSE	   --- s
 *****************************************************************************/
{
	if (hDLL == NULL) {
		return FALSE;
	}
	return (*pAisa23GetVersion)(pdwDllVer, pdwDrvVer);
}

BOOL Aisa23wCreate ( PWORD pwLogSlot )
/*****************************************************************************
 * @\  aISA-P23̔Cӂ̃foCX̎gp錾
 * 	 pwLogSlot	--- gpfoCXi[AhX
 * ߒl	 TRUE		--- 
 *		 FALSE		--- s
 *****************************************************************************/
{
	if (hDLL == NULL) {
		return FALSE;
	}
	return (*pAisa23Create)(pwLogSlot);
}

BOOL Aisa23wClose ( WORD wLogSlot )
/*****************************************************************************
 * @\  aISA-P23̔Cӂ̃foCX̎gpJ
 * 	 wLogSlot  --- gpfoCX
 * ߒl	 TRUE	   --- 
 *		 FALSE	   --- s
 *****************************************************************************/
{
	if (hDLL == NULL) {
		return FALSE;
	}
	return (*pAisa23Close)(wLogSlot);
}

BOOL Aisa23wGetResource ( WORD wLogSlot, PAISA23R pResInfo )
/*****************************************************************************
 * @\  wfoCX̃\[X擾
 * 	 wLogSlot --- ׂfoCX
 *		 pResInfo --- \[Xi[\̂̃AhX
 * ߒl	 TRUE	  --- 
 *		 FALSE	  --- s
 *****************************************************************************/
{
	if (hDLL == NULL) {
		return FALSE;
	}
	return (*pAisa23GetResource)(wLogSlot, pResInfo);
}

BOOL Aisa23wOutPort ( WORD wLogSlot, DWORD dwPort, BYTE bOutValue )
/*****************************************************************************
 * @\  Cӂ̃|[gփf[^o
 * 	 wLogSlot  --- o͂foCX
 *		 dwPort	   --- o͂|[g
 *		 bOutValue --- o̓f[^
 * ߒl	 TRUE	   --- 
 *		 FALSE	   --- s
 *****************************************************************************/
{
	if (hDLL == NULL) {
		return FALSE;
	}
	return (*pAisa23OutPort)(wLogSlot, dwPort, bOutValue);
}

DWORD Aisa23wGetLastError ( WORD wLogSlot )
/*****************************************************************************
 * @\  aISA-P23̃G[R[h
 * 	 wLogSlot  --- G[foCX
 * ߒl	 TRUE	   --- 
 *		 FALSE	   --- s
 *****************************************************************************/
{
	if (hDLL == NULL) {
		return AISA23_ERR_WRAPDLL;
	}
	return (*pAisa23GetLastError)(wLogSlot);
}

static BOOL Aisa23wGetDllExportFunc ( void )
/*---------------------------------------------------------------------------
 * 	 DLLGNX|[g֐AhX̎擾
 * 	 Ȃ
 * ߒl	 TRUE	   --- 
 *		 FALSE	   --- s
 *---------------------------------------------------------------------------*/
{
	// Aisa23GetVersion ̃AhX擾
	pAisa23GetVersion = GetProcAddress(hDLL, _T("Aisa23GetVersion"));
	if (pAisa23GetVersion == NULL) {
		return FALSE;
	}

	// Aisa23Create ̃AhX擾
	pAisa23Create = GetProcAddress(hDLL, _T("Aisa23Create"));
	if (pAisa23Create == NULL) {
		return FALSE;
	}

	// Aisa23Close ̃AhX擾
	pAisa23Close = GetProcAddress(hDLL, _T("Aisa23Close"));
	if (pAisa23Close == NULL) {
		return FALSE;
	}

	// Aisa23GetResource ̃AhX擾
	pAisa23GetResource = GetProcAddress(hDLL, _T("Aisa23GetResource"));
	if (pAisa23GetResource == NULL) {
		return FALSE;
	}

	// Aisa23OutPort ̃AhX擾
	pAisa23OutPort = GetProcAddress(hDLL, _T("Aisa23OutPort"));
	if (pAisa23OutPort == NULL) {
		return FALSE;
	}

	// Aisa23GetLastError ̃AhX擾
	pAisa23GetLastError = GetProcAddress(hDLL, _T("Aisa23GetLastError"));
	if (pAisa23GetLastError == NULL) {
		return FALSE;
	}
	return TRUE;	// SĂ DLL GNX|[g֐AhX擾
}
